PATH=PATH;c:\Progra~2\Java\jre6\bin
@echo off
mode con:cols=75 lines=20
COLOR 70
if (%1)==() (goto skipper)
if (%~x1)==(.zip) (goto qzipper)
goto qfolder
PAUSE
:skipper
set usrc=9
set heapy=512
java -version 
if errorlevel 1 goto errjava
cls
echo Do you want to clean out previous update-script and update.zip (y/n)?
set /P INPUT=Enter: %=%
if %INPUT% == n goto restart
del update.zip
del updateold.zip
rmdir /S /Q "%~dp0placehere\META-INF"
cls
:restart
cls
echo --------------------------------------------------------------------------
echo  ^| Compression-Level: %usrc% ^| Heap Size : %heapy%mb ^| Update.zip Manager : v2.0 ^|
echo --------------------------------------------------------------------------
echo ****************************** Update.zip Creator*************************
echo.
echo   1.   Create update-script
echo   2.   Create Update.zip (from files within placehere folder)
echo   3.   Push to Sdcard
echo   4.   Select compression level for apk's
echo   5.   Set Max Heap Size (Only change if when signing the zip disappears)
echo   6.   Exit
echo.
echo **************************************************************************
echo.
SET /P menunr=Please make your decision: 
IF %menunr%==1 (goto run)
IF %menunr%==2 (goto run1)
IF %menunr%==3 (goto sdcard)
IF %menunr%==4 (goto usrcomp)
IF %menunr%==5 (goto heap)
IF %menunr%==6 (goto exity)
echo Incorrect selection, please try again
PAUSE
goto restart
:run
mkdir placehere\META-INF\com\google\android
cls
echo.
echo ****************************** Update-Script Menu*************************
echo.
echo   1.   Copy directories
echo   2.   Create Symlinks
echo   3.   Delete file
echo   4.   Delete directory
echo   5.   Flash boot image
echo   6.   Set permissions for file
echo   7.   Set permissions for directory
echo   8.   Done
echo.
echo **************************************************************************
echo.
SET /P menunr=Please make your decision: 
IF %menunr%==1 (goto copyd)
IF %menunr%==2 (goto sym)
IF %menunr%==3 (goto dele)
IF %menunr%==4 (goto deler)
IF %menunr%==5 (goto bootimg)
IF %menunr%==6 (goto perm)
IF %menunr%==7 (goto permr)
IF %menunr%==8 (goto restart)
echo Incorrect selection, please try again
PAUSE
goto run
:perm
set /P INPUT3=What partition is the file located in (eg DATA, SYSTEM)?: %=%
set /P INPUT4=What file within that partition (eg app/123.sh)?: %=%
set /P INPUT=UID ?: %=%
set /P INPUT1=GID ?: %=%
set /P INPUT2=MODE ?: %=%
echo Writing
echo set_perm %input% %input1% %input2% %input3%:%input4% >> placehere\META-INF\com\google\android\update-script
goto run
:permr
set /P INPUT3=What partition is directory located in (eg DATA, SYSTEM)?: %=%
set /P INPUT4=What directory within partition, leave blank if whole parition (eg app/abc)?: %=%
set /P INPUT=UID ?: %=%
set /P INPUT1=GID ?: %=%
set /P INPUT2=DIR-MODE ?: %=%
set /P INPUT5=FILE-MODE ?: %=%
echo Writing
echo set_perm_recursive %input% %input1% %input2% %input5% %input3%:%input4% >> placehere\META-INF\com\google\android\update-script
goto run
:sdcard
echo What should update.zip be renamed to before pushing to sdcard (eg hey.zip)
set /P INPUT=Enter name : %=%
adb push update.zip /sdcard/%INPUT%
goto restart
:bootimg
echo Wheres the boot.img located within the placehere folder?
echo eg if in root of placehere then just boot.img, otherwise folder/boot.img
set /P INPUT=So where is it located ?: %=%
echo Writing
echo format BOOT: >> placehere\META-INF\com\google\android\update-script
echo write_raw_image PACKAGE:%input% BOOT: >> placehere\META-INF\com\google\android\update-script
goto run
:copyd
set /P INPUT1=What partition to place files in (eg DATA, SYSTEM)?: %=%
set /P INPUT2=What folder within that partition (eg app,framework)?: %=%
set /P INPUT3=What folder from this update.zip within placehere folder ?: %=%
echo Writing
echo copy_dir PACKAGE:%input3% %input1%:%input2% >> placehere\META-INF\com\google\android\update-script
goto run
:copyf
set /P INPUT1=Where do you want to place the file ? (eg /system/framework/abc.apk): %=%
set /P INPUT2=What file from this update.zip within placehere folder (eg folder/abc.apk) ?: %=%
echo Writing
echo package_extract_file("%input2%", "%input1%"); >> placehere\META-INF\com\google\android\update-script
goto run
:sym
echo Eg. If you want to link /system/app to /data/app, then target: /data/app base-part: SYSTEM  base-dir: app
set /P INPUT1=Target: %=%
set /P INPUT2=Base-part: %=%
set /P INPUT3=Base-dir: %=%
echo Writing
echo symlink %input1% %input2%:%input3% >> placehere\META-INF\com\google\android\update-script
goto run
:dele
set /P INPUT1=What partition do you want to delete the directory from ? (eg DATA, SYSTEM): %=%
set /P INPUT2=What folder from that partition do you want to delete ? (eg app/Calculator.apk): %=%
echo delete %input1%:%input2% >> placehere\META-INF\com\google\android\update-script
goto run
:deler
set /P INPUT1=What partition do you want to delete the file from ? (eg DATA, SYSTEM): %=%
set /P INPUT2=What file from that partition do you want to delete ? (eg media/audio): %=%
echo delete_recursive %input1%:%input2% >> placehere\META-INF\com\google\android\update-script
goto run
:run1
cls
del update.zip
del newupdate.zip
cls
cd other
echo Zipping
7za a -tzip "../updateold.zip" "../placehere/*" -mx%usrc%
echo Signing
java -Xmx%heapy%m -jar signapk.jar -w testkey.x509.pem testkey.pk8 ../updateold.zip ../update.zip
cd ..
del updateold.zip
goto restart
:qfolder
cd %~dp0other
echo Zipping
7za a -tzip %1.zip %1\* -mx9
echo Signing
java -Xmx999m -jar signapk.jar -w testkey.x509.pem testkey.pk8 %1.zip %1.zipa
del %1.zip
ren %1.zipa "%~n1.zip"
cd ..
goto exity
:qzipper
cd %~dp0other
echo Signing
java -Xmx999m -jar signapk.jar -w testkey.x509.pem testkey.pk8 %1 %1a
del %1
ren %1a "%~n1.zip"
cd ..
goto exity
:heap
set /P INPUT=Enter max size for java heap space in megabytes (eg 512) : %=%
set heapy=%INPUT%
cls
goto restart
:usrcomp
set /P INPUT=Enter Compression Level (0-9) : %=%
set usrc=%INPUT%
cls
goto restart
:errjava
cls
echo Java was not found, you will not be able to sign apks or use apktool
PAUSE
goto restart
:exity
